<script lang="ts">
    import Tailwind from '$components/Tailwind.svelte'
    import { onDestroy, onMount } from 'svelte'
    import mercureStore from '$lib/mercureStore'
    import type { MercureStore } from '$lib/mercureStore'
    import user from '$lib/user'
    import { pushSuccess } from '$lib/success'
    import { pushError } from '$lib/errors'
    import BaseError from '$lib/errors/Errors/BaseError'
    import { get } from '$lib/fetch'

    let battle: MercureStore<unknown>

    let victory: MercureStore<unknown>
    let factionVictory: string

    onMount(() => {
        battle = mercureStore('battle/' + $user?.username)
        battle.subscribe(
            (
                message: {
                    data: {
                        win: Boolean
                        to: Number
                        from: Number
                        friend: Boolean
                        username: string
                    }
                }[]
            ) => {
                if (message.length > 0) {
                    let value = message.shift()
                    if (value.data) {
                        if (value.data.win && !value.data.friend) {
                            pushSuccess('You won the battle for the stargate ' + value.data.to)
                        }
                        if (value.data.friend) {
                            pushSuccess('The fleet arrived safely at the stragate ' + value.data.to)
                        } else {
                            pushError(
                                new BaseError(
                                    'You won the battle for the stargate ' + value.data.to
                                )
                            )
                        }
                    }
                }
            }
        )
        get('/api/factions/getPoint').then(({ res }) => {
            res.data.forEach(faction => {
                if (faction.victory) {
                    factionVictory = faction.name
                }
            })
        })
        victory = mercureStore('victory')
        victory.subscribe(value => {
            if (value[0]) {
                factionVictory = value[0].data.faction
            }
        })
    })

    onDestroy(() => {
        battle?.close()
        victory?.close()
    })
</script>

<main>
    <slot />
    {#if factionVictory}
        <div class="modal-victory">
            <svg
                xmlns="http://www.w3.org/2000/svg"
                class="h-12 w-12"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
            >
                <path
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M12 9v2m0 4h.01m-6.938 4h13.856c1.54 0 2.502-1.667 1.732-3L13.732 4c-.77-1.333-2.694-1.333-3.464 0L3.34 16c-.77 1.333.192 3 1.732 3z"
                />
            </svg>
            <p>
                The {factionVictory} win the game ! Thank you for playing, we hope you have taken a good
                time playing our game.
            </p>
        </div>
    {/if}
</main>

<Tailwind />

<style lang="postcss">
    main {
        @apply min-h-screen;
    }

    .modal-victory {
        @apply fixed right-0 bottom-0 rounded mb-4 mr-4 p-3 max-w-2xl flex space-x-4 text-lg font-bold items-center
            bg-gradient-to-r from-indigo-200 to-fuchsia-200
          dark:from-indigo-900 dark:to-fuchsia-900 dark:text-white;

        svg {
            @apply text-fuchsia-200;
        }
    }
</style>
